Index: trunk/sources/HeuristicLab.Parameters/3.3/OptionalConstrainedValueParameter.cs
===================================================================
--- trunk/sources/HeuristicLab.Parameters/3.3/OptionalConstrainedValueParameter.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Parameters/3.3/OptionalConstrainedValueParameter.cs	(revision 3317)
@@ -33,17 +33,12 @@
   [StorableClass]
   public class OptionalConstrainedValueParameter<T> : Parameter, IValueParameter<T> where T : class, IItem {
+    [Storable]
     private ItemSet<T> validValues;
-    [Storable]
     public ItemSet<T> ValidValues {
       get { return validValues; }
-      private set {
-        DeregisterValidValuesEvents();
-        validValues = value;
-        RegisterValidValuesEvents();
-      }
     }
 
+    [Storable]
     private T value;
-    [Storable]
     public virtual T Value {
       get { return this.value; }
@@ -74,37 +69,53 @@
     public OptionalConstrainedValueParameter()
       : base("Anonymous", typeof(T)) {
-      ValidValues = new ItemSet<T>();
+      this.validValues = new ItemSet<T>();
+      Initialize();
     }
     public OptionalConstrainedValueParameter(string name)
       : base(name, typeof(T)) {
-      ValidValues = new ItemSet<T>();
+      this.validValues = new ItemSet<T>();
+      Initialize();
     }
     public OptionalConstrainedValueParameter(string name, ItemSet<T> validValues)
       : base(name, typeof(T)) {
-      ValidValues = validValues;
+      this.validValues = validValues;
+      Initialize();
     }
     public OptionalConstrainedValueParameter(string name, ItemSet<T> validValues, T value)
       : base(name, typeof(T)) {
-      ValidValues = validValues;
-      Value = value;
+      this.validValues = validValues;
+      this.value = value;
+      Initialize();
     }
     public OptionalConstrainedValueParameter(string name, string description)
       : base(name, description, typeof(T)) {
-      ValidValues = new ItemSet<T>();
+      this.validValues = new ItemSet<T>();
+      Initialize();
     }
     public OptionalConstrainedValueParameter(string name, string description, ItemSet<T> validValues)
       : base(name, description, typeof(T)) {
-      ValidValues = validValues;
+      this.validValues = validValues;
+      Initialize();
     }
     public OptionalConstrainedValueParameter(string name, string description, ItemSet<T> validValues, T value)
       : base(name, description, typeof(T)) {
-      ValidValues = validValues;
-      Value = value;
+      this.validValues = validValues;
+      this.value = value;
+      Initialize();
+    }
+    [StorableConstructor]
+    protected OptionalConstrainedValueParameter(bool deserializing) : base(deserializing) { }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      RegisterValidValuesEvents();
+      if (value != null) value.ToStringChanged += new EventHandler(Value_ToStringChanged);
     }
 
     public override IDeepCloneable Clone(Cloner cloner) {
       OptionalConstrainedValueParameter<T> clone = (OptionalConstrainedValueParameter<T>)base.Clone(cloner);
-      clone.ValidValues = (ItemSet<T>)cloner.Clone(validValues);
-      clone.Value = (T)cloner.Clone(value);
+      clone.validValues = (ItemSet<T>)cloner.Clone(validValues);
+      clone.value = (T)cloner.Clone(value);
+      clone.Initialize();
       return clone;
     }
Index: trunk/sources/HeuristicLab.Parameters/3.3/OptionalValueParameter.cs
===================================================================
--- trunk/sources/HeuristicLab.Parameters/3.3/OptionalValueParameter.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Parameters/3.3/OptionalValueParameter.cs	(revision 3317)
@@ -32,6 +32,6 @@
   [StorableClass]
   public class OptionalValueParameter<T> : Parameter, IValueParameter<T> where T : class, IItem {
+    [Storable]
     private T value;
-    [Storable]
     public virtual T Value {
       get { return this.value; }
@@ -66,5 +66,6 @@
     public OptionalValueParameter(string name, T value)
       : base(name, typeof(T)) {
-      Value = value;
+      this.value = value;
+      Initialize();
     }
     public OptionalValueParameter(string name, string description)
@@ -73,10 +74,19 @@
     public OptionalValueParameter(string name, string description, T value)
       : base(name, description, typeof(T)) {
-      Value = value;
+      this.value = value;
+      Initialize();
+    }
+    [StorableConstructor]
+    protected OptionalValueParameter(bool deserializing) : base(deserializing) { }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      if (value != null) value.ToStringChanged += new EventHandler(Value_ToStringChanged);
     }
 
     public override IDeepCloneable Clone(Cloner cloner) {
       OptionalValueParameter<T> clone = (OptionalValueParameter<T>)base.Clone(cloner);
-      clone.Value = (T)cloner.Clone(value);
+      clone.value = (T)cloner.Clone(value);
+      clone.Initialize();
       return clone;
     }
Index: trunk/sources/HeuristicLab.Parameters/3.3/Parameter.cs
===================================================================
--- trunk/sources/HeuristicLab.Parameters/3.3/Parameter.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Parameters/3.3/Parameter.cs	(revision 3317)
@@ -91,4 +91,6 @@
       this.dataType = dataType;
     }
+    [StorableConstructor]
+    protected Parameter(bool deserializing) : base(deserializing) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
Index: trunk/sources/HeuristicLab.Parameters/3.3/ValueLookupParameter.cs
===================================================================
--- trunk/sources/HeuristicLab.Parameters/3.3/ValueLookupParameter.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Parameters/3.3/ValueLookupParameter.cs	(revision 3317)
@@ -32,6 +32,6 @@
   [StorableClass]
   public class ValueLookupParameter<T> : LookupParameter<T>, IValueLookupParameter<T> where T : class, IItem {
+    [Storable]
     private T value;
-    [Storable]
     public T Value {
       get { return this.value; }
@@ -66,5 +66,6 @@
     public ValueLookupParameter(string name, T value)
       : base(name) {
-      Value = value;
+      this.value = value;
+      Initialize();
     }
     public ValueLookupParameter(string name, string description)
@@ -73,13 +74,22 @@
     public ValueLookupParameter(string name, string description, T value)
       : base(name, description) {
-      Value = value;
+      this.value = value;
+      Initialize();
     }
     public ValueLookupParameter(string name, string description, string actualName)
       : base(name, description, actualName) {
     }
+    [StorableConstructor]
+    protected ValueLookupParameter(bool deserializing) : base(deserializing) { }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      if (value != null) value.ToStringChanged += new EventHandler(Value_ToStringChanged);
+    }
 
     public override IDeepCloneable Clone(Cloner cloner) {
       ValueLookupParameter<T> clone = (ValueLookupParameter<T>)base.Clone(cloner);
-      clone.Value = (T)cloner.Clone(value);
+      clone.value = (T)cloner.Clone(value);
+      clone.Initialize();
       return clone;
     }
Index: trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/AntTrail.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/AntTrail.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/AntTrail.cs	(revision 3317)
@@ -34,6 +34,6 @@
   [StorableClass]
   public sealed class AntTrail : Item {
+    [Storable]
     private SymbolicExpressionTree expression;
-    [Storable]
     public SymbolicExpressionTree SymbolicExpressionTree {
       get { return expression; }
@@ -48,6 +48,6 @@
     }
 
+    [Storable]
     private BoolMatrix world;
-    [Storable]
     public BoolMatrix World {
       get { return world; }
@@ -61,6 +61,6 @@
       }
     }
+    [Storable]
     private IntValue maxTimeSteps;
-    [Storable]
     public IntValue MaxTimeSteps {
       get { return maxTimeSteps; }
@@ -80,7 +80,17 @@
     public AntTrail(BoolMatrix world, SymbolicExpressionTree expression, IntValue maxTimeSteps)
       : this() {
-      World = world;
-      SymbolicExpressionTree = expression;
-      MaxTimeSteps = maxTimeSteps;
+      this.world = world;
+      this.expression = expression;
+      this.maxTimeSteps = maxTimeSteps;
+      Initialize();
+    }
+    [StorableConstructor]
+    private AntTrail(bool deserializing) : base(deserializing) { }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      //if (expression != null) RegisterSymbolicExpressionTreeEvents();
+      if (world != null) RegisterWorldEvents();
+      if (maxTimeSteps != null) RegisterMaxTimeStepsEvents();
     }
 
@@ -88,7 +98,9 @@
       AntTrail clone = new AntTrail();
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       clone.expression = (SymbolicExpressionTree)cloner.Clone(expression);
       clone.world = (BoolMatrix)cloner.Clone(world);
       clone.maxTimeSteps = (IntValue)cloner.Clone(maxTimeSteps);
+      clone.Initialize();
       return clone;
     }
Index: trunk/sources/HeuristicLab.Problems.TravelingSalesman/3.3/PathTSPTour.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.TravelingSalesman/3.3/PathTSPTour.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Problems.TravelingSalesman/3.3/PathTSPTour.cs	(revision 3317)
@@ -39,6 +39,6 @@
     }
 
+    [Storable]
     private DoubleMatrix coordinates;
-    [Storable]
     public DoubleMatrix Coordinates {
       get { return coordinates; }
@@ -52,6 +52,6 @@
       }
     }
+    [Storable]
     private Permutation permutation;
-    [Storable]
     public Permutation Permutation {
       get { return permutation; }
@@ -69,9 +69,20 @@
     public PathTSPTour(DoubleMatrix coordinates)
       : base() {
-      Coordinates = coordinates;
+      this.coordinates = coordinates;
+      Initialize();
     }
     public PathTSPTour(DoubleMatrix coordinates, Permutation permutation)
-      : this(coordinates) {
-      Permutation = permutation;
+      : base() {
+      this.coordinates = coordinates;
+      this.permutation = permutation;
+      Initialize();
+    }
+    [StorableConstructor]
+    private PathTSPTour(bool deserializing) : base(deserializing) { }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      if (coordinates != null) RegisterCoordinatesEvents();
+      if (permutation != null) RegisterPermutationEvents();
     }
 
@@ -79,6 +90,8 @@
       PathTSPTour clone = new PathTSPTour();
       cloner.RegisterClonedObject(this, clone);
-      clone.Coordinates = (DoubleMatrix)cloner.Clone(coordinates);
-      clone.Permutation = (Permutation)cloner.Clone(permutation);
+      clone.ReadOnlyView = ReadOnlyView;
+      clone.coordinates = (DoubleMatrix)cloner.Clone(coordinates);
+      clone.permutation = (Permutation)cloner.Clone(permutation);
+      clone.Initialize();
       return clone;
     }
Index: trunk/sources/HeuristicLab.Random/3.3/MersenneTwister.cs
===================================================================
--- trunk/sources/HeuristicLab.Random/3.3/MersenneTwister.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Random/3.3/MersenneTwister.cs	(revision 3317)
@@ -84,6 +84,5 @@
     /// <returns>The cloned object as <see cref="MersenneTwister"/>.</returns>
     public override IDeepCloneable Clone(Cloner cloner) {
-      MersenneTwister clone = new MersenneTwister();
-      cloner.RegisterClonedObject(this, clone);
+      MersenneTwister clone = (MersenneTwister)base.Clone(cloner);
       clone.state = (uint[])state.Clone();
       clone.p = p;
Index: trunk/sources/HeuristicLab.Random/3.3/NormalDistributedRandom.cs
===================================================================
--- trunk/sources/HeuristicLab.Random/3.3/NormalDistributedRandom.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Random/3.3/NormalDistributedRandom.cs	(revision 3317)
@@ -553,6 +553,8 @@
     /// <returns>The cloned object as <see cref="NormalDistributedRandom"/>.</returns>
     public override IDeepCloneable Clone(Cloner cloner) {
-      NormalDistributedRandom clone = new NormalDistributedRandom((IRandom)cloner.Clone(uniform), mu, sigma);
-      cloner.RegisterClonedObject(this, clone);
+      NormalDistributedRandom clone = (NormalDistributedRandom)base.Clone(cloner);
+      clone.uniform = (IRandom)cloner.Clone(uniform);
+      clone.mu = mu;
+      clone.sigma = sigma;
       return clone;
     }
